﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        RadTreeViewItem clickedElement;

        public MainPage()
        {
            InitializeComponent();

            this.radTreeView.AddHandler(RadMenuItem.ClickEvent, new RoutedEventHandler(OnContextMenuClick));
        }

        private void RadContextMenu_Opened(object sender, RoutedEventArgs e)
        {
            // Find the tree item that is associated with the clicked context menu item
            clickedElement = (sender as RadContextMenu).GetClickedElement<RadTreeViewItem>();
        }

        private void OnContextMenuClick(object sender, RoutedEventArgs args)
        {
            // Get the clicked context menu item
            RadMenuItem menuItem = ((RadRoutedEventArgs)args).OriginalSource as RadMenuItem;

            League league = clickedElement.Item as League;
            System.Windows.Controls.ItemsControl parentItemsControl = (System.Windows.Controls.ItemsControl)clickedElement.ParentItem ?? clickedElement.ParentTreeView;
            string header = menuItem.Header as string;
            switch (header)
            {
                case "New Child":
                    league.Divisions.Add(new Division("New Division"));
                    break;
                case "New Sibling":
                    (parentItemsControl.ItemsSource as ObservableCollection<League>).Add(new League("New League"));
                    break;
                case "Delete":
                    (parentItemsControl.ItemsSource as ObservableCollection<League>).Remove(league);
                    clickedElement = null;
                    break;
            }
        }
    }

    public class Team
    {
        public Team(string name)
        {
            this.Name = name;
        }
        public string Name
        {
            get;
            set;
        }
    }

    public class Division
    {
        public Division(string name)
        {
            this.Name = name;
            this.Teams = new ObservableCollection<Team>();
        }
        public string Name
        {
            get;
            set;
        }
        public ObservableCollection<Team> Teams
        {
            get;
            set;
        }
    }

    public class League
    {
        public League(string name)
        {
            this.Name = name;
            this.Divisions = new ObservableCollection<Division>();
        }
        public string Name
        {
            get;
            set;
        }
        public ObservableCollection<Division> Divisions
        {
            get;
            set;
        }
    }

    public class RadTreeViewSampleData
    {
        public RadTreeViewSampleData()
        {
            this.InitializeLeaguesDataSource();
        }
        public ObservableCollection<League> LeaguesDataSource
        {
            get;
            set;
        }
        private void InitializeLeaguesDataSource()
        {
            this.LeaguesDataSource = new ObservableCollection<League>();
            League l;
            Division d;
            this.LeaguesDataSource.Add(l = new League("League A"));
            l.Divisions.Add((d = new Division("Division A")));
            d.Teams.Add(new Team("Team I"));
            d.Teams.Add(new Team("Team II"));
            d.Teams.Add(new Team("Team III"));
            d.Teams.Add(new Team("Team IV"));
            d.Teams.Add(new Team("Team V"));
            l.Divisions.Add((d = new Division("Division B")));
            d.Teams.Add(new Team("Team Blue"));
            d.Teams.Add(new Team("Team Red"));
            d.Teams.Add(new Team("Team Yellow"));
            d.Teams.Add(new Team("Team Green"));
            d.Teams.Add(new Team("Team Orange"));
            l.Divisions.Add((d = new Division("Division C")));
            d.Teams.Add(new Team("Team East"));
            d.Teams.Add(new Team("Team West"));
            d.Teams.Add(new Team("Team North"));
            d.Teams.Add(new Team("Team South"));
            this.LeaguesDataSource.Add(l = new League("League B"));
            l.Divisions.Add((d = new Division("Division A")));
            d.Teams.Add(new Team("Team 1"));
            d.Teams.Add(new Team("Team 2"));
            d.Teams.Add(new Team("Team 3"));
            d.Teams.Add(new Team("Team 4"));
            d.Teams.Add(new Team("Team 5"));
            l.Divisions.Add((d = new Division("Division B")));
            d.Teams.Add(new Team("Team Diamond"));
            d.Teams.Add(new Team("Team Heart"));
            d.Teams.Add(new Team("Team Club"));
            d.Teams.Add(new Team("Team Spade"));
            l.Divisions.Add((d = new Division("Division C")));
            d.Teams.Add(new Team("Team Alpha"));
            d.Teams.Add(new Team("Team Beta"));
            d.Teams.Add(new Team("Team Gamma"));
            d.Teams.Add(new Team("Team Delta"));
            d.Teams.Add(new Team("Team Epsilon"));
        }
    }
}
